#!/bin/sh

[ -n "$1" ] && VersionKernel=$1 || VersionKernel=`uname -r`

cd `dirname $0`

rm -f modules.dep.snd modules.dep all-sound-modules
rm -rf module-dep
mkdir module-dep

cat /lib/modules/$VersionKernel/modules.dep | while read ligne
do
    echo "$ligne" >> modules.dep
done

CopieModule()
{
    [ -z "$1" -o -z "$2" ] && return
    local Mod module #FicLoadModule
    module=$1
    FicLoadModule=$2
    echo "$module" | grep "\.o$" > /dev/null && module=`echo $module | sed "s/\.o$//"`
    echo "$module.o" >> all-sound-modules
    Dep=`grep "$module.o:" modules.dep | sed "s/.*://"`

    for ModDep in $Dep
    do
        ModDep=`echo $ModDep | sed -e "s;/lib/modules/$VersionKernel/;;" \
                                   -e "s/\.o//"`
        CopieModule $ModDep $FicLoadModule
    done

    Mod=`basename $module`

    grep "$Mod" $FicLoadModule > /dev/null || echo "lsmod | grep \"^$Mod\" > /dev/null || insmod $Mod" >> $FicLoadModule
}

touch snd-pcm-oss
#CopieModule "misc/snd-pcm-oss" snd-pcm-oss
PcmOss=`grep "snd-pcm-oss" modules.dep | \
cut -d":" -f1 | \
sed -e "s;/lib/modules/$VersionKernel/;;" -e "s/\.o//"`

CopieModule $PcmOss snd-pcm-oss
#grep "/lib/modules/$VersionKernel/misc/snd-" /lib/modules/$VersionKernel/modules.dep | tr ':' ' ' | tr -s ' ' '\n' | while read module
grep "snd-" /lib/modules/$VersionKernel/modules.dep | tr ':' ' ' | tr -s ' ' '\n' | while read module
do
    echo -n "$module"

    Mod=`echo $module | sed -e "s;.*$VersionKernel/;;" -e "s/://g"`

    FicLoad="module-dep/load-`basename $module`"
    cp snd-pcm-oss $FicLoad
    CopieModule $Mod $FicLoad
    echo "."
done
cat all-sound-modules | sort | uniq > all-sound-modules.old
mv -f all-sound-modules.old all-sound-modules
rm -f snd-pcm-oss

