#!/bin/sh

cd `dirname $0`

FicModulesDep=/lib/modules/$VersionKernel/modules.dep

[ $# -lt 1 ] && echo >&2 "Usage : `basename $0` <module carte son>

Exemple : snd-card-es1968
" && exit 1
CarteSon=$1
CarteSon=`echo $CarteSon | sed "s/\.o$//"`
[ -n "$2" ] && VersionKernel=$2 || VersionKernel=`uname -r`

#[ ! -f /lib/modules/$VersionKernel/misc/$CarteSon.o ] && echo >&2 "Module $CarteSon non compile" && exit 1
[ ! -f /lib/modules/$VersionKernel/modules.dep ] && echo "Fichier /lib/modules/$VersionKernel/modules.dep n'existe pas" && exit 1

! grep "$CarteSon.o:" /lib/modules/$VersionKernel/modules.dep > /dev/null && echo >&2 "Module $CarteSon non compile" && exit 1

cat /lib/modules/$VersionKernel/modules.dep | while read ligne
do
    echo "$ligne" >> /tmp/modules.dep
done

FicModulesDep=/tmp/modules.dep

CopieModule()
{
    local Mod module
    module=$1
    local Space="$2"
    echo "$module" | grep "\.o$" > /dev/null && module=`echo $module | sed "s/\.o$//"`
    #echo "$module"
    Dep=`grep "$module.o:" $FicModulesDep`
    Dep=`echo $Dep | sed "s/.*://"`

    for ModDep in $Dep
    do
        #echo "$module -> $ModDep"
        ModDep=`echo $ModDep | sed -e "s;/lib/modules/$VersionKernel/;;" \
                                   -e "s/\.o//"`
        #echo "${Space}$module -> $ModDep"
        #echo "$Space $ModDep"
        CopieModule $ModDep "$Space    " #$2
    done

    #echo $module
    Mod=`basename $module`
    #echo "$Space $Mod"
    grep "^$Mod" /tmp/snd.$$ > /dev/null || echo "$Mod" #>> $2
    echo "$Mod" >> /tmp/snd.$$
    #echo "lsmod | grep \"^$Mod\" > /dev/null || insmod $Mod" #>> $2
}

touch /tmp/snd.$$

CopieModule snd-pcm-oss
CopieModule $CarteSon

rm -f /tmp/snd.$$
rm -f /tmp/modules.dep
